function [B,Dm,C,Cp,m] = compute_UVold(U,P,P_c,gamma,mu,r,op)

       
[n1,n2]=size(U);
n=n1*n2;
u=reshape(U,n,1);

p=reshape(P,n,2);
q(:,1)=p(:,2);
q(:,2)=p(:,1);

p_c=reshape(P_c,n,2);
q_c(:,1)=p_c(:,2);
q_c(:,2)=p_c(:,1);



%-------- B ---------------------------------------------------------------
B= -mu*op.LAP;
%--------------------------------------------------------------------------


%-------- Dm --------------------------------------------------------------
gradu(:,1)= op.GRAD(1:n,:)*u;
gradu(:,2)= op.GRAD(n+1:2*n,:)*u;

srgradu = sum((gradu).^2,2);
etagradu = sqrt(srgradu);

m=max(gamma, etagradu);
m1=1./m;
Dm=spdiags([m1;m1],0,2*n,2*n);

%--------------------------------------------------------------------------


% %-------- Dm --------------------------------------------------------------
% gradu(:,1)= op.GRAD(1:n,:)*u;
% gradu(:,2)= op.GRAD(n+1:2*n,:)*u;
% 
% srgradu = sum((abs(gradu)).^r,2);
% etagradu = srgradu.^((r-1)/r);
% 
% m=max(gamma, etagradu);
% m1=m.^-1;
% Dm=spdiags([m1;m1],0,2*n,2*n);
% %------------------------------------------------------------------------



%-------- C  --------------------------------------------------------------
xsi(:,1)=1./controlz(etagradu); %xsi^-1(grad(u))
xsi(:,2)=xsi(:,1);

chi(:,1)=etagradu>= gamma;
chi(:,2)=chi(:,1);

ad = 1 - chi.*p.*xsi.*gradu;
cb = - chi.*q.*xsi.* gradu;

C=(r-1)*spdiags( [cb(:) ad(:) cb(:)], [-n 0 n], 2*n, 2*n);


%sum_cb=sum(cb,2);
%prod_ad=prod(ad,2);
%tc1=sum_cb.^2<=4*prod_ad;
%vorherC=numel(tc1)-sum(sum(tc1))
%--------------------------------------------------------------------------

clear ad cb;




%-------- C modified ------------------------------------------------------
%xsi(:,1)=1./etagradu; %xsi^-1(grad(u))

ad = 1 - chi.*p_c.*xsi.*gradu;
cb = - chi.*q_c.*xsi.* gradu;


ad=max(ad,0);% should be positive anyway because of correction_P

prod_ad=prod(ad,2);
sum_cb=sum(cb,2);

tc=sum_cb.^2<=4*prod_ad;
ss=sign(sum_cb).*(1-tc);
%anfangCp= numel(tc)-sum(sum(tc))

%mmmm=max(sum_cb.^2-4*prod_ad)


fff=find(tc==0);
cc=cb(:,1);
bb=cb(:,2);

nu_a=ones(numel(tc),1);

nu_a(fff)=2*sqrt(prod_ad(fff))./(abs(sum_cb(fff)));

rechen_genau=eps;
cc=cc.*nu_a-ss*rechen_genau;
bb=bb.*nu_a-ss*rechen_genau;
%cc=cc.*nu_a;
%bb=bb.*nu_a;


cb(:,1)=cc;
cb(:,2)=bb;


%symmetrization
% cb(:,1)=0.5*(sum(cb,2));
% cb(:,2)=cb(:,1);


% 
% nu_a=2*sqrt(prod_ad)./controlz(abs(sum_cb));
% %nu_a=2*sqrt(prod_ad)./(abs(sum_cb));
% 
% tc=sum_cb.^2<=4*prod_ad;
% 
% anfag= numel(tc)-sum(sum(tc))
% 
% nu(:,1)=tc+(1-tc).*nu_a;
% nu(:,2)=nu(:,1);
% 
% cb=cb.*nu;
% 
 %sum_cb=sum(cb,2);
 %tc2=sum_cb.^2<=4*prod_ad;
 %danachCp=numel(tc2)-sum(sum(tc2))
 
 
Cp=(r-1)*spdiags( [cb(:) ad(:) cb(:)], [-n 0 n], 2*n, 2*n);
%--------------------------------------------------------------------------
















% %-------- C ---------------------------------------------------------------
% xsi(:,1)=controlz(srgradu).^(-1/r).*sign(srgradu); %xsi^-1(grad(u))
% xsi(:,2)=xsi(:,1);
% 
% chi(:,1)=etagradu>= gamma;
% chi(:,2)=chi(:,1);
% 
% 
% ad = abs(gradu).^(r-2) - chi.*p.*xsi.*abs(gradu).^(r-1).*sign(gradu);
% cb = - chi.*q.*xsi.* abs(gradu).^(r-1).*sign(gradu);
% 
% 
% ad=max(ad,0);% should be positive anyway because of correction_P
% 
% prod_ad=prod(ad,2);
% sum_cb=sum(cb,2);
% 
% %srp = sum((abs(p)).^r,2);
% %etap = srp.^((r-1)/r);
% 
% %invalid_P=sum(etap>1)
% 
% tc=sum_cb.^2<=4*prod_ad;
% ss=sign(sum_cb).*(1-tc);
% 
% 
% anfang= numel(tc)-sum(sum(tc))
% 
% fff=find(tc==0);
% cc=cb(:,1);
% bb=cb(:,2);
% 
% nu_a=ones(numel(tc),1);
% 
% nu_a(fff)=2*sqrt(prod_ad(fff))./(abs(sum_cb(fff)));
% 
% cc=cc.*nu_a-ss*5e-16;
% bb=bb.*nu_a-ss*5e-16;
% 
% cb(:,1)=cc;
% cb(:,2)=bb;
% 
% 
% % 
% % nu_a=2*sqrt(prod_ad)./controlz(abs(sum_cb));
% % %nu_a=2*sqrt(prod_ad)./(abs(sum_cb));
% % 
% % tc=sum_cb.^2<=4*prod_ad;
% % 
% % anfag= numel(tc)-sum(sum(tc))
% % 
% % nu(:,1)=tc+(1-tc).*nu_a;
% % nu(:,2)=nu(:,1);
% % 
% % cb=cb.*nu;
% % 
%  sum_cb=sum(cb,2);
%  tc2=sum_cb.^2<=4*prod_ad;
%  danach=numel(tc2)-sum(sum(tc2))
%  
% 
% C=(r-1)*spdiags( [cb(:) ad(:) cb(:)], [-n 0 n], 2*n, 2*n);
% %--------------------------------------------------------------------------
% 
      


