global blur_p blur_para noise_type noise_para std_dev   % degraded image information
global r mu gamma bc                                    % primal-dual model
global local_var_est om zeta kmax                       % update lambda
global ls_parameter res_tol imax i_p cg_imax pk_p pk_para % Newton steps
    
%% noise and blurring operator information

blur_p=0; %1:yes, 0:no

if blur_p==1
    blur_fs=9;              % kernel size
    blur_fv=1;              % standard deviation
    blur_para=[blur_fs,blur_fv];        
elseif blur_p==0
    blur_para=[];
end

noise_type=1;               % 1: Gaussian noise; 2: salt-and-pepper noise

if noise_type==1
    expected_value=0;
    std_dev=0.02;            % standard deviation
    noise_para=[expected_value, std_dev];    
elseif noise_type==2
    noise=0.2;              % s&p noise ratio
    noise_para=noise;        
end

%% Parameters in the primal-dual model

r=2;
if blur_p==0
    mu=0;
else
    mu=1e-6;                % relevant only for the deblurring 
end
gamma=1e-4;                 % regularization parameter of the dual problem

bc='d';                     % boundary condition n: neumann d: dirichlet


%% Parameters for spatially dependent parameter, lambda, updating

local_var_est=1;            % 1:using variance estimator for lambda, 0: scalar lambda

lambda=2.5;                 % initial value
om=11;                      % filter width for lambda with local variance estimator
zeta=2;                     % increasing number of lambda


kmax=10;                    % the maximum number of the outer iterations


%% Parameters in Semismooth-Newton steps

ls_parameter=0;             % 1:linesearch yes, 0:no

res_tol=1e-4;               % relative residual of newton iteration i (stopping rule)
imax=50;                    % the maximum number of the inner iterations

check_iteration=1;

i_p=1;                      % 0:mldivide(\) 1:bicg
cg_imax=100;                 % the maximum number of bicg iterations
pk_p=0;                     % 0:no preconditioner, 1:preconditioner cholinc, 2 own preconditioner
if pk_p==0
    pk_para=[];
elseif pk_p==1
    pk_para=1e-3;              % accuracy preconditioner cholinc
elseif pk_p==2
    pk_para=0;               % using own preconditioner
end

%% Output

opicname='outputpic';    
